ctdb-scripts: Compact server-end TCP connection killing output
[samba.git] / ctdb / config / functions
index 727bd8661b8f392fa5a21d823b367ee9fc180547..2c630bd11bee8fb5e683eab3022cd1e4747ffaa2 100755 (executable)
@@ -97,26 +97,6 @@ loadconfig () {
 
 ##############################################################
 
-# CTDB_SCRIPT_DEBUGLEVEL can be overwritten by setting it in a
-# configuration file.
-debug ()
-{
-    if [ "${CTDB_SCRIPT_DEBUGLEVEL:-NOTICE}" = "DEBUG" ] ; then
-       # If there are arguments then echo them.  Otherwise expect to
-       # use stdin, which allows us to pass lots of debug using a
-       # here document.
-       if [ -n "$1" ] ; then
-           echo "DEBUG: $*"
-       else
-           sed -e 's@^@DEBUG: @'
-       fi
-    else
-       if [ -z "$1" ] ; then
-           cat >/dev/null
-       fi
-    fi
-}
-
 die ()
 {
     _msg="$1"
@@ -358,67 +338,40 @@ ctdb_check_directories()
 # usage: ctdb_check_tcp_ports <ports...>
 ######################################################
 
-# This flag file is created when a service is initially started.  It
-# is deleted the first time TCP port checks for that service succeed.
-# Until then ctdb_check_tcp_ports() prints a more subtle "error"
-# message if a port check fails.
-_ctdb_check_tcp_common ()
-{
-    assert_service_name
-    _d="${CTDB_SCRIPT_VARDIR}/failcount"
-    _ctdb_service_started_file="${_d}/${service_name}.started"
-}
-
-ctdb_check_tcp_init ()
-{
-    _ctdb_check_tcp_common
-    mkdir -p "${_ctdb_service_started_file%/*}" # dirname
-    touch "$_ctdb_service_started_file"
-}
-
 # Check whether something is listening on all of the given TCP ports
 # using the "ctdb checktcpport" command.
 ctdb_check_tcp_ports()
 {
-    if [ -z "$1" ] ; then
-       echo "INTERNAL ERROR: ctdb_check_tcp_ports - no ports specified"
-       exit 1
-    fi
-
-    for _p ; do  # process each function argument (port)
-       _cmd="$CTDB checktcpport $_p"
-       _out=$($_cmd 2>&1)
-       _ret=$?
-       case "$_ret" in
-           0)
-               _ctdb_check_tcp_common
-               if [ ! -f "$_ctdb_service_started_file" ] ; then
-                   echo "ERROR: $service_name tcp port $_p is not responding"
-                   debug "\"ctdb checktcpport $_p\" was able to bind to port"
-               else
-                   echo "INFO: $service_name tcp port $_p is not responding"
-               fi
+       if [ -z "$1" ] ; then
+               echo "INTERNAL ERROR: ctdb_check_tcp_ports - no ports specified"
+               exit 1
+       fi
 
-               return 1
-               ;;
-           98)
-               # Couldn't bind, something already listening, next port...
-               continue
-               ;;
-           *)
-               echo "ERROR: unexpected error running \"ctdb checktcpport\""
-               debug <<EOF
-$CTDB checktcpport (exited with $_ret) with output:
-$_out"
-EOF
-               return $_ret
-       esac
-    done
+       for _p ; do  # process each function argument (port)
+               _cmd="$CTDB checktcpport $_p"
+               _out=$($_cmd 2>&1)
+               _ret=$?
+               case "$_ret" in
+               0)
+                       echo "$service_name not listening on TCP port $_p"
+                       return 1
+                       ;;
+               98)
+                       # Couldn't bind, something already listening, next port
+                       continue
+                       ;;
+               *)
+                       echo "unexpected error (${_ret}) running \"${_cmd}\""
+                       if [ -n "$_out" ] ; then
+                               echo "$_out"
+                       fi
+                       return $_ret
+                       ;;
+               esac
+       done
 
-    # All ports listening
-    _ctdb_check_tcp_common
-    rm -f "$_ctdb_service_started_file"
-    return 0
+       # All ports listening
+       return 0
 }
 
 ######################################################
@@ -435,19 +388,6 @@ ctdb_check_unix_socket() {
     fi
 }
 
-######################################################
-# check a command returns zero status
-# usage: ctdb_check_command <command>
-######################################################
-ctdb_check_command ()
-{
-    _out=$("$@" 2>&1) || {
-       echo "ERROR: $* returned error"
-       echo "$_out" | debug
-       exit 1
-    }
-}
-
 ################################################
 # kill off any TCP connections with the given IP
 ################################################
@@ -474,7 +414,6 @@ kill_tcp_connections ()
                139|445) __oneway=true ;;
            esac
 
-           echo "Killing TCP connection $_src $_dst"
            _connections="${_connections}${_nl}${_src} ${_dst}"
            if ! $__oneway ; then
                _connections="${_connections}${_nl}${_dst} ${_src}"
@@ -493,15 +432,22 @@ kill_tcp_connections ()
                return
        }
 
-       _remaining=$(get_tcp_connections_for_ip "$_ip" | wc -l)
-
-       if [ "$_remaining" -eq 0 ] ; then
-               echo "Killed $_killcount TCP connections to released IP $_ip"
-               return
+       _connections=$(get_tcp_connections_for_ip "$_ip")
+       if [ -z "$_connections" ] ; then
+               _remaining=0
+       else
+               _remaining=$(echo "$_connections" | wc -l)
        fi
 
-       _t="${_remaining}/${_killcount}"
-       echo "Failed to kill TCP connections for IP $_ip (${_t} remaining)"
+       _actually_killed=$((_killcount - _remaining))
+
+       _t="${_actually_killed}/${_killcount}"
+       echo "Killed ${_t} TCP connections to released IP $_ip"
+
+       if [ -n "$_connections" ] ; then
+               echo "Remaining connections:"
+               echo "$_connections" | sed -e 's|^|  |'
+       fi
     }
 }
 
@@ -782,33 +728,6 @@ ctdb_setup_service_state_dir ()
        echo "$_service_state_dir"
 }
 
-########################################################
-# Managed status history, for auto-start/stop
-
-_ctdb_managed_common ()
-{
-    _ctdb_managed_file="${CTDB_SCRIPT_VARDIR}/managed_history/${service_name}"
-}
-
-ctdb_service_managed ()
-{
-    _ctdb_managed_common
-    mkdir -p "${_ctdb_managed_file%/*}" # dirname
-    touch "$_ctdb_managed_file"
-}
-
-ctdb_service_unmanaged ()
-{
-    _ctdb_managed_common
-    rm -f "$_ctdb_managed_file"
-}
-
-is_ctdb_previously_managed_service ()
-{
-    _ctdb_managed_common
-    [ -f "$_ctdb_managed_file" ]
-}
-
 ##################################################################
 # Reconfigure a service on demand
 
@@ -853,141 +772,8 @@ service_reconfigure ()
     :
 }
 
-ctdb_reconfigure_take_lock ()
-{
-       _ctdb_service_reconfigure_common
-       _lock="${_d}/reconfigure_lock"
-       mkdir -p "${_lock%/*}" # dirname
-       touch "$_lock"
-
-       (
-               flock 9
-               # This is overkill but will work if we need to extend
-               # this to allow certain events to run multiple times
-               # in parallel (e.g. takeip) and write multiple PIDs to
-               # the file.
-               {
-                       read _locker_event
-                       if [ -n "$_locker_event" ] ; then
-                               while read _pid ; do
-                                       if [ -n "$_pid" -a "$_pid" != $$ ] && \
-                                          kill -0 "$_pid" 2>/dev/null ; then
-                                               exit 1
-                                       fi
-                               done
-                       fi
-               } <"$_lock"
-
-               printf "%s\n%s\n" "$event_name" $$ >"$_lock"
-               exit 0
-    ) 9>"${_lock}.flock"
-}
-
-ctdb_reconfigure_release_lock ()
-{
-    _ctdb_service_reconfigure_common
-    _lock="${_d}/reconfigure_lock"
-
-    rm -f "$_lock"
-}
-
-ctdb_replay_monitor_status ()
-{
-    echo "Replaying previous status for this script due to reconfigure..."
-    # Leading separator ('|') is missing in some versions...
-    _out=$($CTDB scriptstatus -X | grep -E "^\|?monitor\|${script_name}\|")
-    # Output looks like this:
-    # |monitor|60.nfs|1|ERROR|1314764004.030861|1314764004.035514|foo bar|
-    # This is the cheapest way of getting fields in the middle.
-    # Intentional word splitting here
-    # shellcheck disable=SC2046,2086
-    set -- $(IFS="|" ; echo $_out)
-    _code="$3"
-    _status="$4"
-    # The error output field can include colons so we'll try to
-    # preserve them.  The weak checking at the beginning tries to make
-    # this work for both broken (no leading '|') and fixed output.
-    _out="${_out%|}"
-    _err_out="${_out#*monitor|${script_name}|*|*|*|*|}"
-    case "$_status" in
-       OK) : ;;  # Do nothing special.
-       TIMEDOUT)
-           # Recast this as an error, since we can't exit with the
-           # correct negative number.
-           _code=1
-           _err_out="[Replay of TIMEDOUT scriptstatus - note incorrect return code.] ${_err_out}"
-           ;;
-       DISABLED)
-           # Recast this as an OK, since we can't exit with the
-           # correct negative number.
-           _code=0
-           _err_out="[Replay of DISABLED scriptstatus - note incorrect return code.] ${_err_out}"
-           ;;
-       *) : ;;  # Must be ERROR, do nothing special.
-    esac
-    if [ -n "$_err_out" ] ; then
-       echo "$_err_out"
-    fi
-    exit $_code
-}
-
-ctdb_service_check_reconfigure ()
-{
-    assert_service_name
-
-    # We only care about some events in this function.  For others we
-    # return now.
-    case "$event_name" in
-       monitor|ipreallocated|reconfigure) : ;;
-       *) return 0 ;;
-    esac
-
-    if ctdb_reconfigure_take_lock ; then
-       # No events covered by this function are running, so proceed
-       # with gay abandon.
-       case "$event_name" in
-           reconfigure)
-               (ctdb_service_reconfigure)
-               exit $?
-               ;;
-           ipreallocated)
-               if ctdb_service_needs_reconfigure ; then
-                   ctdb_service_reconfigure
-               fi
-               ;;
-       esac
-
-       ctdb_reconfigure_release_lock
-    else
-       # Somebody else is running an event we don't want to collide
-       # with.  We proceed with caution.
-       case "$event_name" in
-           reconfigure)
-               # Tell whoever called us to retry.
-               exit 2
-               ;;
-           ipreallocated)
-               # Defer any scheduled reconfigure and just run the
-               # rest of the ipreallocated event, as per the
-               # eventscript.  There's an assumption here that the
-               # event doesn't depend on any scheduled reconfigure.
-               # This is true in the current code.
-               return 0
-               ;;
-           monitor)
-               # There is most likely a reconfigure in progress so
-               # the service is possibly unstable.  As above, we
-               # defer any scheduled reconfigured.  We also replay
-               # the previous monitor status since that's the best
-               # information we have.
-               ctdb_replay_monitor_status
-               ;;
-       esac
-    fi
-}
-
 ##################################################################
-# Does CTDB manage this service? - and associated auto-start/stop
+# Does CTDB manage this service?
 
 ctdb_compat_managed_service ()
 {
@@ -1026,75 +812,6 @@ is_ctdb_managed_service ()
     [ "${t#* ${service_name} }" != "${t}" ]
 }
 
-ctdb_start_stop_service ()
-{
-    assert_service_name
-
-    # Allow service-start/service-stop pseudo-events to start/stop
-    # services when we're not auto-starting/stopping and we're not
-    # monitoring.
-    case "$event_name" in
-       service-start)
-           if is_ctdb_managed_service ; then
-               die 'service-start event not permitted when service is managed'
-           fi
-           if [ "$CTDB_SERVICE_AUTOSTARTSTOP" = "yes" ] ; then
-               die 'service-start event not permitted with CTDB_SERVICE_AUTOSTARTSTOP=yes'
-           fi
-           ctdb_service_start
-           exit $?
-           ;;
-       service-stop)
-           if is_ctdb_managed_service ; then
-               die 'service-stop event not permitted when service is managed'
-           fi
-           if [ "$CTDB_SERVICE_AUTOSTARTSTOP" = "yes" ] ; then
-               die 'service-stop event not permitted with CTDB_SERVICE_AUTOSTARTSTOP=yes'
-           fi
-           ctdb_service_stop
-           exit $?
-           ;;
-    esac
-
-    # Do nothing unless configured to...
-    [ "$CTDB_SERVICE_AUTOSTARTSTOP" = "yes" ] || return 0
-
-    [ "$event_name" = "monitor" ] || return 0
-
-    if is_ctdb_managed_service ; then
-       if ! is_ctdb_previously_managed_service ; then
-           echo "Starting service \"$service_name\" - now managed"
-           background_with_logging ctdb_service_start
-           exit $?
-       fi
-    else
-       if is_ctdb_previously_managed_service ; then
-           echo "Stopping service \"$service_name\" - no longer managed"
-           background_with_logging ctdb_service_stop
-           exit $?
-       fi
-    fi
-}
-
-ctdb_service_start ()
-{
-    # The service is marked managed if we've ever tried to start it.
-    ctdb_service_managed
-
-    service_start || return $?
-
-    # Intentionally have this use $service_name as default
-    # shellcheck disable=SC2119
-    ctdb_counter_init
-    ctdb_check_tcp_init
-}
-
-ctdb_service_stop ()
-{
-    ctdb_service_unmanaged
-    service_stop
-}
-
 # Default service_start() and service_stop() functions.
  
 # These may be overridden in an eventscript.
@@ -1301,4 +1018,3 @@ update_tickles ()
 }
 
 script_name="${0##*/}"       # basename
-event_name="$1"